#include <SlidWind.h>

tSlidW::sender sent;
tSlidW::recipient rec;
tSlidW::timeout tim;
tSlidW sliding_window;
tTimer timer;
uint32_t id=1;
uint32_t mask=0x7FE00;
byte data_sent /*[]*/ [8];//={'0','1','2','3','4','5','6','7','8','9'};
//uint8_t data_length=sizeof(data_sent)/sizeof(data_sent[0]);

uint16_t id_sent;
uint8_t leng;
byte data_rec [8];

bool stringComplete = false;

int cont=0;
String incom;

void setup() {
  // put your setup code here, to run once:
  sliding_window.init_sliding_window(id,mask,mask);
  //Serial.print(F("Longitud data:  "));Serial.println(data_length);
  timer.start_timer();
}

void loop() {
  if(cont<1000){      
      //uint32_t first=millis();
       // put your main code here, to run repeatedly:
        Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
        Serial.println(F("//////////////////////NUEVA ITERACIÓN LOOP///////////////////////////////"));
        Serial.println(F("/////////////////////////////////////////////////////////////////////////"));

       if(Serial.availableForWrite()){
           Serial.print("La ristra contiene ");Serial.println(incom);
         while(incom.length()>0){
            sliding_window.get_byte_data(incom, data_sent,leng);
            Serial.print("Valores del vector: ");
            for (int i=0;i<8;i++){
              Serial.println((char)data_sent[i]);
            }
            Serial.print("La ristra contiene ");Serial.println(incom);
              
            //////////////Parte envío////////////////////////////
            if(sliding_window.sent_packet(id,2,8,data_sent, sent, rec, tim)){
                //sliding_window.print_sender(sent);
                Serial.print("Se realizó un envío");
                cont++;
                Serial.print(F("Trama "));Serial.println(cont);
                sliding_window.print_timeout(tim);
            }
          } 
       }
      ///////////////Parte recepción/////////////////////
      if(sliding_window.receive_packet(rec,sent,tim)){
          Serial.println(F("Messages"));
          sliding_window.print_timeout(tim);
      }else{
         Serial.println(F("No Messages"));
      }
      if(stringComplete){
         Serial.print("La ristra contiene ");Serial.println(incom);
         while(incom.length()>0){
            sliding_window.get_byte_data(incom, data_sent,leng);
            Serial.print("Valores del vector: ");
            for (int i=0;i<8;i++){
              Serial.println((char)data_sent[i]);
            }
            Serial.print("La ristra contiene ");Serial.println(incom);
              
            //////////////Parte envío////////////////////////////
            if(sliding_window.sent_packet(id,2,8,data_sent, sent, rec, tim)){
                //sliding_window.print_sender(sent);
                Serial.print("Se realizó un envío");
                cont++;
                Serial.print(F("Trama "));Serial.println(cont);
                sliding_window.print_timeout(tim);
            }
          }
          incom = "";
          stringComplete = false;
      }
  } 

    
       //if((timer.get_value_of_timer()+30000)<=timer.get_time_ms()||(sent.send_occupieds==4)){
          Serial.println("Comprobación de timers");     
            ///////////////Comprobación timers envío//////////
          if(sliding_window.check_output_timers(rec,sent)){
            Serial.println(F("Algun timer de salida ha expirado y ha reenviado la trama"));  
          }else{
            Serial.println(F("Ningun timer de salida ha expirado"));
          }
          
          ///////////////Comprobación timers recepción//////////
       /*   if(sliding_window.check_input_timers(rec,sent)){
            Serial.println(F("Algun timer de entrada ha expirado y ha mandado ack"));  
          }else{
            Serial.println(F("Ningun timer de entrada ha expirado"));
          }
         // timer.start_timer();
       //} */
        Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
        Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
        Serial.println(F("/////////////////////////////////////////////////////////////////////////"));/*
        uint32_t last=millis()-first;
        Serial.print("Tiempo bucle ms");Serial.println(last);
    */
     
}

void SerialEvent(){
  char inChar;
  while(Serial.available()){
    inChar=(char) Serial.read();
    incom+=inChar;
  }
  if (inChar == '\n'){
      stringComplete = true;
  }
}

