#include <SlidWind.h>

tSlidW::sender sent;
tSlidW::recipient rec;
tSlidW sliding_window;
tTimer timer;
uint32_t id=1;
uint32_t mask=0x7FE00;
byte data_sent[] ={'0','1','2','3','4','5','6','7','8','9'};
uint8_t data_length=sizeof(data_sent)/sizeof(data_sent[0]);

uint16_t id_sent;
uint8_t leng;
byte data_rec [8];




void setup() {
  // put your setup code here, to run once:
  sliding_window.init_sliding_window(id,mask,mask);
  Serial.print(F("Longitud data:  "));Serial.println(data_length);
  timer.start_timer();
}

void loop() {
  uint32_t first=millis();
   // put your main code here, to run repeatedly:
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    Serial.println(F("//////////////////////NUEVA ITERACIÓN LOOP///////////////////////////////"));
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
  
  
  //////////////Parte envío////////////////////////////
  if(sliding_window.sent_packet(id,2,8,data_sent, sent, rec)){
      sliding_window.print_sender(sent);
  }
  
  ///////////////Parte recepción/////////////////////
  if(sliding_window.receive_packet(rec,sent)){
      Serial.println(F("Messages"));
      while(rec.rec_occupieds>0){
        if(sliding_window.get_data(id_sent,leng,data_rec,rec)){
          Serial.print(F("id: "));Serial.println(id);
          Serial.print(F("leng: "));Serial.println(leng);
          Serial.print("data: ");
          for(int i=0;i<leng;i++){
            Serial.print(static_cast<char>(data_rec[i]));
          }
          Serial.println();
          Serial.print("rec.rec_occupieds: ");Serial.println(rec.rec_occupieds);
          sliding_window.print_recipient(rec);
          Serial.println("//////////////////////////////////////////////////////////////////");
        }else{
          break;      
        }
      }
      sliding_window.print_recipient(rec);
  }else{
     Serial.println(F("No Messages"));
  }

   if((timer.get_value_of_timer()+30000)<=timer.get_time_ms()||(sent.send_occupieds==4)){
      Serial.println("Comprobación de timers");     
        ///////////////Comprobación timers envío//////////
      if(sliding_window.check_output_timers(rec,sent)){
        Serial.println(F("Algun timer de salida ha expirado y ha reenviado la trama"));  
      }else{
        Serial.println(F("Ningun timer de salida ha expirado"));
      }
      
      ///////////////Comprobación timers recepción//////////
      if(sliding_window.check_input_timers(rec,sent)){
        Serial.println(F("Algun timer de entrada ha expirado y ha mandado ack"));  
      }else{
        Serial.println(F("Ningun timer de entrada ha expirado"));
      }
      timer.start_timer();
   }   
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
  uint32_t last=millis()-first;
  Serial.print("Tiempo bucle ms");Serial.println(last);
}



