#include <SlidWind.h>

tSlidW::sender sent;
tSlidW::recipient rec;
tSlidW::timeout tim;
tSlidW sliding_window;
tTimer timer;

uint32_t id=2;
uint32_t mask=0x7FE00;

uint16_t id_sent;
uint8_t leng;
byte data_rec [8];

void setup() {
  // put your setup code here, to run once:
  sliding_window.init_sliding_window(id,mask,mask);
  timer.start_timer();
}


void loop() {
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    Serial.println(F("//////////////////////NUEVA ITERACIÓN LOOP///////////////////////////////"));
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    
  ///////////////Parte recepción/////////////////////
  if(sliding_window.receive_packet(rec,sent,tim)){
      Serial.println(F("Messages"));
      /*sliding_window.print_recipient(rec);*/
      
  }else{
     Serial.println(F("No Messages"));
  }
 
      ///////////////Comprobación timers recepción//////////
      if(sliding_window.check_input_timers(rec,sent)){
        Serial.println(F("Algun timer de entrada ha expirado y ha mandado ack"));
        sliding_window.print_timeout(tim);
        while(rec.rec_occupieds>0){
            if(sliding_window.get_data(id_sent,leng,data_rec,rec)){
              Serial.println("//////////////////////////////////////////////////////////////////");
            }else{
              break;      
            }
        }    
      }else{
        Serial.println(F("Ningun timer de entrada ha expirado"));
      }
      //timer.start_timer();
   //} 

    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));
    Serial.println(F("/////////////////////////////////////////////////////////////////////////"));/*
    uint32_t last=millis()-first;
    Serial.print("Tiempo bucle ms");Serial.println(last);*/
    Serial.print("Paquetes bien recibidos: ");Serial.println(rec.goods_r);
    Serial.print("Paquetes mal recibidos: ");Serial.println(rec.bads_r);
    Serial.print("Tasa de recepción: ");Serial.println((double) rec.bads_r/(double)rec.goods_r,3); 
    
}
